Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/content.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/content.php	(revision 1264)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/content.php	(revision 1265)
@@ -4,13 +4,15 @@
 ?>
 <article id="post-<?php echo $theme->slug; ?>" class="theme hentry">
-	<div class="theme-screenshot">
-		<img src="<?php echo esc_url( $theme->screenshot_url . '?w=572&strip=all' ); ?>" alt="">
-	</div>
-	<a class="more-details url" href="<?php echo esc_url( home_url( $theme->slug . '/' ) ); ?>" rel="bookmark"><?php _ex( 'More Info', 'theme' ); ?></a>
-	<div class="theme-author"><?php printf( __( 'By %s' ), '<span class="author">' . $theme->author . '</span>' ); ?></div>
-	<h3 class="theme-name entry-title"><?php echo $theme->name; ?></h3>
+	<a class="url" href="<?php echo esc_url( home_url( $theme->slug . '/' ) ); ?>" rel="bookmark" tabindex="-1">
+		<div class="theme-screenshot">
+			<img src="<?php echo esc_url( $theme->screenshot_url . '?w=572&strip=all' ); ?>" alt="">
+		</div>
+		<span class="more-details"><?php _ex( 'More Info', 'theme' ); ?></span>
+		<div class="theme-author"><?php printf( __( 'By %s' ), '<span class="author">' . $theme->author . '</span>' ); ?></div>
+		<h3 class="theme-name entry-title"><?php echo $theme->name; ?></h3>
 
-	<div class="theme-actions">
-		<a class="button button-primary preview install-theme-preview" href="<?php echo esc_url( '//downloads.wordpress.org/theme/' . $theme->slug . '.' . $theme->version . '.zip' ); ?>"><?php esc_html_e( 'Download' ); ?></a>
-	</div>
+		<div class="theme-actions">
+			<a class="button button-primary preview install-theme-preview" href="<?php echo esc_url( '//downloads.wordpress.org/theme/' . $theme->slug . '.' . $theme->version . '.zip' ); ?>"><?php esc_html_e( 'Download' ); ?></a>
+		</div>
+	</a>
 </article>
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/js/theme.js
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/js/theme.js	(revision 1264)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/js/theme.js	(revision 1265)
@@ -154,4 +154,9 @@
 
 			event = event || window.event;
+
+			// Don't handle click if command/Ctrl are pressed to open the link in a new tab.
+			if ( true === event.metaKey && 'click' === event.type ) {
+				return;
+			}
 
 			// 'enter' and 'space' keys expand the details view when a theme is :focused
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/view-templates/theme.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/view-templates/theme.php	(revision 1264)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/view-templates/theme.php	(revision 1265)
@@ -1,16 +1,18 @@
 <script id="tmpl-theme" type="text/template">
-	<# if ( data.screenshot_url ) { #>
-	<div class="theme-screenshot">
-		<img src="{{ data.screenshot_url }}?w=572&strip=all" alt="" />
-	</div>
-	<# } else { #>
-	<div class="theme-screenshot blank"></div>
-	<# } #>
-	<a class="more-details url" href="{{{ data.permalink }}}" rel="bookmark" tabindex="-1"><?php _ex( 'More Info', 'theme' ); ?></a>
-	<div class="theme-author"><?php printf( __( 'By %s' ), '<span class="author">{{ data.author }}</span>' ); ?></div>
-	<h3 class="theme-name entry-title">{{{ data.name }}}</h3>
+	<a class="url" href="{{{ data.permalink }}}" rel="bookmark" tabindex="-1">
+		<# if ( data.screenshot_url ) { #>
+		<div class="theme-screenshot">
+			<img src="{{ data.screenshot_url }}?w=572&strip=all" alt="" />
+		</div>
+		<# } else { #>
+		<div class="theme-screenshot blank"></div>
+		<# } #>
+		<span class="more-details"><?php _ex( 'More Info', 'theme' ); ?></span>
+		<div class="theme-author"><?php printf( __( 'By %s' ), '<span class="author">{{ data.author }}</span>' ); ?></div>
+		<h3 class="theme-name entry-title">{{{ data.name }}}</h3>
 
-	<div class="theme-actions">
-		<a class="button button-primary preview install-theme-preview" href="//downloads.wordpress.org/theme/{{ data.slug }}.{{ data.version }}.zip"><?php esc_html_e( 'Download' ); ?></a>
-	</div>
+		<div class="theme-actions">
+			<a class="button button-primary preview install-theme-preview" href="//downloads.wordpress.org/theme/{{ data.slug }}.{{ data.version }}.zip"><?php esc_html_e( 'Download' ); ?></a>
+		</div>
+	</a>
 </script>