Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/class-customizations.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/class-customizations.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/class-customizations.php	(revision 5318)
@@ -131,5 +131,5 @@
 
 		if ( empty( $query->query['post_status'] ) ) {
-			$query->query_vars['post_status'] = array( 'publish', 'future', 'draft', 'pending', 'disabled', 'closed', 'rejected', 'approved' );
+			$query->query_vars['post_status'] = array( 'publish', 'future', 'new', 'pending', 'disabled', 'closed', 'rejected', 'approved' );
 		}
 
@@ -176,5 +176,5 @@
 			'post_type'      => 'plugin',
 			'post__in'       => array_map( 'absint', $_REQUEST['post'] ),
-			'post_status'    => array( 'draft', 'pending' ),
+			'post_status'    => array( 'new', 'pending' ),
 			'posts_per_page' => count( $_REQUEST['post'] ),
 		) );
@@ -238,5 +238,5 @@
 
 		switch ( $post->post_status ) {
-			case 'draft':
+			case 'new':
 				$message = __( 'This plugin is newly requested and has not yet been reviewed.', 'wporg-plugins' );
 				$type    = 'notice-info';
@@ -366,5 +366,5 @@
 		);
 
-		if ( 'draft' !== $post->post_status ) {
+		if ( 'new' !== $post->post_status && 'pending' != $post->post_status ) {
 			add_meta_box(
 				'plugin-committers',
@@ -381,5 +381,5 @@
 
 		// Remove slug metabox unless the slug is editable for the current user.
-		if ( ! in_array( $post->post_status, array( 'draft', 'pending' ) ) || ! current_user_can( 'plugin_approve', $post ) ) {
+		if ( ! in_array( $post->post_status, array( 'new', 'pending' ) ) || ! current_user_can( 'plugin_approve', $post ) ) {
 			remove_meta_box( 'slugdiv', 'plugin', 'normal' );
 		}
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/class-status-transitions.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/class-status-transitions.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/class-status-transitions.php	(revision 5318)
@@ -57,5 +57,5 @@
 
 		// ...or it's a white-listed status for plugin reviewers.
-		if ( current_user_can( 'plugin_review', $postarr['ID'] ) && in_array( $postarr['post_status'], array( 'draft', 'pending' ) ) ) {
+		if ( current_user_can( 'plugin_review', $postarr['ID'] ) && in_array( $postarr['post_status'], array( 'new', 'pending' ) ) ) {
 			return $data;
 		}
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/list-table/class-plugin-posts.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/list-table/class-plugin-posts.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/list-table/class-plugin-posts.php	(revision 5318)
@@ -80,5 +80,5 @@
 		}
 
-		if ( current_user_can( 'plugin_reject' ) && ( empty( $_REQUEST['post_status'] ) || in_array( $_REQUEST['post_status'], array( 'draft', 'pending' ) ) ) ) {
+		if ( current_user_can( 'plugin_reject' ) && ( empty( $_REQUEST['post_status'] ) || in_array( $_REQUEST['post_status'], array( 'new', 'pending' ) ) ) ) {
 			$actions['plugin_reject'] = __( 'Reject', 'wporg-plugins' );
 		}
@@ -407,5 +407,5 @@
 			}
 
-			if ( ! current_user_can( 'plugin_approve' ) && ! in_array( $status_name, array( 'draft', 'pending' ) ) ) {
+			if ( ! current_user_can( 'plugin_approve' ) && ! in_array( $status_name, array( 'new', 'pending' ) ) ) {
 				continue;
 			}
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-author-card.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-author-card.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-author-card.php	(revision 5318)
@@ -149,5 +149,5 @@
 
 					$plugin_slug = $plugin->post_name;
-					if ( in_array( $plugin->post_status, array( 'draft', 'pending' ) ) ) {
+					if ( in_array( $plugin->post_status, array( 'new', 'pending' ) ) ) {
 						$extra .= ' (requested ' . human_time_diff( strtotime( $last_updated ) ) . ' ago)';
 						$tooltips[] = 'Requested, remains unapproved.';
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-controls.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-controls.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-controls.php	(revision 5318)
@@ -41,10 +41,10 @@
 		}
 
-		$statuses = array( 'draft', 'pending' );
+		$statuses = array( 'new', 'pending' );
 		if ( current_user_can( 'plugin_approve', $post ) ) {
-			if ( in_array( $post->post_status, array( 'draft', 'pending', 'rejected', 'approved' ) ) ) {
+			if ( in_array( $post->post_status, array( 'new', 'draft', 'pending', 'rejected', 'approved' ) ) ) {
 				$statuses = array_merge( $statuses, array( 'approved', 'rejected' ) );
 			} else {
-				$statuses = array( 'publish', 'disabled', 'closed' );
+				$statuses = array( 'publish', 'disabled', 'closed', 'pending' );
 			}
 		}
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-review-tools.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-review-tools.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/metabox/class-review-tools.php	(revision 5318)
@@ -11,20 +11,24 @@
 		$post = get_post();
 
-		$zip_url = '';
+		$zip_files = array();
 		foreach ( get_attached_media( 'application/zip', $post ) as $zip_file ) {
-			$zip_url = wp_get_attachment_url( $zip_file->ID );
-			break;
+			$zip_files[ $zip_file->post_date ] = wp_get_attachment_url( $zip_file->ID );
 		}
-		if ( ! $zip_url ) {
-			$zip_url = get_post_meta( $post->ID, '_submitted_zip', true );
+		uksort( $zip_files, function( $a, $b ) {
+			return strtotime( $a ) < strtotime( $b );
+		} );
+
+		if ( $zip_url = get_post_meta( $post->ID, '_submitted_zip', true ) ) {
+			// Back-compat only.
+			$zip_files[ 'User provided URL' ] = $zip_url;
 		}
 
-		if ( $zip_url ) {
+		foreach ( $zip_files as $zip_date => $zip_url ) {
 			printf( '<p>' . __( '<strong>Zip file:</strong> %s', 'wporg-plugins' ) . '</p>',
-				sprintf( '<a href="%s">%s</a>', esc_url( $zip_url ), esc_html( $zip_url ) )
+				sprintf( '%s <a href="%s">%s</a>', esc_html( $zip_date ), esc_url( $zip_url ), esc_html( $zip_url ) )
 			);
 		}
 
-		if ( 'pending' != $post->post_status ) {
+		if ( 'pending' != $post->post_status && 'new' != $post->post_status ) {
 			echo "<ul>
 				<li><a href='https://plugins.trac.wordpress.org/log/{$post->post_name}/'>" . __( 'Development Log', 'wporg-plugins' ) . "</a></li>
@@ -33,5 +37,5 @@
 			</ul>';
 		}
-		if ( $post->post_excerpt && in_array( $post->post_status, array( 'pending', 'approved' ) ) ) {
+		if ( $post->post_excerpt && in_array( $post->post_status, array( 'new', 'pending', 'approved' ) ) ) {
 			echo '<p>' . strip_tags( $post->post_excerpt ) . '</p>';
 		}
@@ -41,5 +45,5 @@
 			
 			$type   = 'Notice';
-			if ( $post->post_status == 'draft' || $post->post_status == 'pending' ) {
+			if ( $post->post_status == 'new' || $post->post_status == 'pending' ) {
 				$type = 'Request';
 			}
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/tools/class-stats-report.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/tools/class-stats-report.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/admin/tools/class-stats-report.php	(revision 5318)
@@ -108,5 +108,5 @@
 		// # of plugins currently in the queue that are drafts (have not been processed/replied to yet)
 		$stats['in_queue_draft'] = $wpdb->get_var(
-			"SELECT COUNT(*) FROM $wpdb->posts WHERE `post_type` = 'plugin' AND `post_status` = 'draft'"
+			"SELECT COUNT(*) FROM $wpdb->posts WHERE `post_type` = 'plugin' AND `post_status` = 'new'"
 		);
 
@@ -121,5 +121,5 @@
 		// # of plugins currently in the queue submitted during the specified time window
 		$stats['in_queue_from_time_window'] = $wpdb->get_var( $wpdb->prepare(
-			"SELECT COUNT(*) FROM $wpdb->posts WHERE `post_type` = 'plugin' AND `post_status` IN ( 'draft','pending' ) AND post_date < %s AND post_date > DATE_SUB( %s, INTERVAL %d DAY )",
+			"SELECT COUNT(*) FROM $wpdb->posts WHERE `post_type` = 'plugin' AND `post_status` IN ( 'new','pending' ) AND post_date < %s AND post_date > DATE_SUB( %s, INTERVAL %d DAY )",
 			$args['date'],
 			$args['date'],
@@ -129,5 +129,5 @@
 		// # of plugins currently in the queue that are older than "recently"
 		$stats['in_queue_old'] = $wpdb->get_var( $wpdb->prepare(
-			"SELECT COUNT(*) FROM $wpdb->posts WHERE `post_type` = 'plugin' AND `post_status` IN ( 'draft','pending' ) AND post_date < DATE_SUB( %s, INTERVAL %d DAY )",
+			"SELECT COUNT(*) FROM $wpdb->posts WHERE `post_type` = 'plugin' AND `post_status` IN ( 'new','pending' ) AND post_date < DATE_SUB( %s, INTERVAL %d DAY )",
 			$args['date'],
 			absint( $args['recentdays'] ) + 1
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/class-plugin-directory.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/class-plugin-directory.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/class-plugin-directory.php	(revision 5318)
@@ -284,4 +284,10 @@
 		) );
 
+		register_post_status( 'new', array(
+			'label'                     => _x( 'Pending Initial Review', 'plugin status', 'wporg-plugins' ),
+			'public'                    => false,
+			'show_in_admin_status_list' => current_user_can( 'plugin_review' ),
+			'label_count'               => _n_noop( 'Pending Initial Review <span class="count">(%s)</span>', 'Pending Initial Review <span class="count">(%s)</span>', 'wporg-plugins' ),
+		) );
 		register_post_status( 'pending', array(
 			'label'                     => _x( 'Pending', 'plugin status', 'wporg-plugins' ),
@@ -793,5 +799,5 @@
 		if ( $viewing_own_author_archive || ( is_user_logged_in() && !empty( $wp_query->query_vars['name'] ) ) ) {
 
-			$wp_query->query_vars['post_status'] = array( 'pending', 'approved', 'publish', 'closed', 'disabled' );
+			$wp_query->query_vars['post_status'] = array( 'approved', 'publish', 'closed', 'disabled' );
 
 			add_filter( 'posts_results', function( $posts, $this_wp_query ) use( $wp_query ) {
@@ -1193,5 +1199,5 @@
 				'post_type'   => 'plugin',
 				'name'        => $plugin_slug,
-				'post_status' => array( 'publish', 'pending', 'disabled', 'closed', 'draft', 'approved' ),
+				'post_status' => array( 'publish', 'pending', 'disabled', 'closed', 'new', 'draft', 'approved' ),
 			) );
 
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/shortcodes/class-upload-handler.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/shortcodes/class-upload-handler.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/shortcodes/class-upload-handler.php	(revision 5318)
@@ -97,7 +97,15 @@
 
 		// Is there already a plugin by a different author?
-		if ( $plugin_post instanceof \WP_Post && $plugin_post->post_author != get_current_user_id() ) {
+		if ( $plugin_post && $plugin_post->post_author != get_current_user_id() ) {
 			/* translators: %s: plugin slug */
 			return sprintf( __( 'There is already a plugin called %s by a different author. Please change the name of your plugin in the plugin header file and upload it again.', 'wporg-plugins' ),
+				'<code>' . $this->plugin_slug . '</code>'
+			);
+		}
+
+		// Check the plugin can accept uploads (New submissions, or pending further review).
+		if ( $plugin_post && ! in_array( $plugin_post->post_status, array( 'new', 'pending' ) ) ) {
+			/* translators: %s: plugin slug */
+			return sprintf( __( 'There is already a plugin called %s. Please change the name of your plugin in the plugin header file and upload it again.', 'wporg-plugins' ),
 				'<code>' . $this->plugin_slug . '</code>'
 			);
@@ -171,5 +179,5 @@
 				'post_title'   => $this->plugin['Name'],
 				'post_name'    => $this->plugin_slug,
-				'post_status'  => 'draft',
+				'post_status'  => 'new',
 				'post_content' => $content,
 				'post_excerpt' => $this->plugin['Description'],
@@ -205,4 +213,5 @@
 					'usage'                    => array(),
 					'_author_ip'               => preg_replace( '/[^0-9a-fA-F:., ]/', '', $_SERVER['REMOTE_ADDR'] ),
+					'_submitted_date'          => time(),
 				),
 			) );
Index: /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/shortcodes/class-upload.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/shortcodes/class-upload.php	(revision 5317)
+++ /sites/trunk/wordpress.org/public_html/wp-content/plugins/plugin-directory/shortcodes/class-upload.php	(revision 5318)
@@ -32,18 +32,11 @@
 					<p>
 						<?php
-						printf( _n( 'Currently there is %1$s plugin in the review queue.', 'Currently there are %1$s plugins in the review queue, %2$s of which are awaiting their initial review.', ( $plugins->draft + $plugins->pending ), 'wporg-plugins' ),
-							'<strong>' . ( $plugins->draft + $plugins->pending ) . '</strong>',
-							'<strong>' . $plugins->draft . '</strong>'
+						printf( _n( 'Currently there is %1$s plugin in the review queue.', 'Currently there are %1$s plugins in the review queue, %2$s of which are awaiting their initial review.', ( $plugins->new + $plugins->pending ), 'wporg-plugins' ),
+							'<strong>' . ( $plugins->new + $plugins->pending ) . '</strong>',
+							'<strong>' . $plugins->new . '</strong>'
 						);
 						?>
 					</p>
 				</div>
-				<?php
-				if ( '/plugins-wp' === parse_url( home_url(), PHP_URL_PATH ) ) {
-					echo '<div class="notice notice-error notice-alt">
-						<p>Please submit all new plugin requests through the existing form <a href="https://wordpress.org/plugins/add/">available here</a>, You\'re currently viewing the beta version of the upcoming plugin directory, and this form is only for testing purposes.</p>
-					</div>';
-				}
-				?>
 
 			<?php endif; ?>